function outputwrite(output, name, dimapp)
%For the fdr2dGUI table show
%% Gan Xinjun, Fudan University

if dimapp == 1

    dat = output.th(:,1:end-1);   % output.th(:,end) = index;
    % height = size(dat,1);
    width = size(dat,2);    % the width of the table;
    index = output.th(:,end);
    % ind2sub in upper
    J = round(floor(-.5 + .5 * sqrt(1 + 8 * (index - 1))) + 2);
    I = round(J .* (3 - J) / 2 + index - 1);

    rowname = name(I);
    colname = name(J);
    name = [rowname colname];
    dat = [num2cell(dat) name];

    f = figure();

    if width == 2    %  1-D pvalue and fwer   
        
        columnname =   {'Stats', 'p-value','Region 1','Region 2'};
        columnformat = {'numeric', 'numeric', 'char', 'char'};
        columneditable =  [false false false false]; 
        
    elseif width == 3 % fdr1d or FDRBH
        
        columnname = {'Stats', 'p-values','fdr','Region 1','Region 2'};
        columnformat = {'numeric', 'numeric', 'numeric', 'char', 'char'};
        columneditable =  [false false false false false]; 
        
    elseif width == 5 % sam
        
        columnname = {'D-val', 'Std-dev', 'Raw_P-val', 'Q-val', 'Fold-Change','Region 1','Region 2'};
        columnformat = {'numeric', 'numeric', 'numeric', 'numeric','numeric','char', 'char'};
        columneditable =  [false false false false false false false]; 
        
    end
    
    t = uitable('Units','normalized','Position',...
            [0.05 0.05 0.95 0.9], 'Data', dat,... 
            'ColumnName', columnname,...
            'ColumnFormat', columnformat,...
            'ColumnEditable', columneditable,...
            'RowName',[]);
end

if dimapp == 2
    
    dat = output.th(:,1:end-1);   % output.th(:,end) = index;
    % height = size(dat,1);
    width = size(dat,2);    % the width of the table;
    index = output.th(:,end);
    % ind2sub in upper
    J = round(floor(-.5 + .5 * sqrt(1 + 8 * (index - 1))) + 2);
    I = round(J .* (3 - J) / 2 + index - 1);

    rowname = name(I);
    colname = name(J);
    name = [rowname colname];
    dat = [num2cell(dat) name];

    f = figure();

    if width == 5 % fdr2d & fisher & meta
    
        columnname = {'Stats 1', 'Stats 2', 'p-value 1', 'p-value 2',...
            'fdr', 'Region 1','Region 2'};
        columnformat = {'numeric', 'numeric', 'numeric', 'numeric',...
            'numeric','char','char'};
        columneditable =  [false false false false]; 
    
    elseif width == 4 % intersection
 
        columnname = {'Stats 1', 'Stats 2', 'p-value 1', 'p-value 2',...
            'Region 1','Region 2'};
        columnformat = {'numeric', 'numeric', 'numeric', 'numeric',...
            'char','char'};
        columneditable =  [false false false false]; 

    end
    
    t = uitable('Units','normalized','Position',...
            [0.05 0.05 0.95 0.9], 'Data', dat,... 
            'ColumnName', columnname,...
            'ColumnFormat', columnformat,...
            'ColumnEditable', columneditable,...
            'RowName',[]);
end
        