function co_links = pickcommon(output1, output2, alpha, output2d, q)
%% To get the common links by the output of 2-D approach
% If output2d does not exist, the co_links will be the intersection of
% output1 and output2. If output2d exist, a 2-D fdr constrain will be added.
% that is to say, output2d.fdr < q.
% Arguments
%   output, a struc, the result by fdrbh, sam
% Values
%   logic, the index of Common links
%% Gan Xinjun, Fudan University
% 
if (~exist('q','var') || isempty(q))
    q = 0.5;
end

if (~exist('alpha','var') || isempty(alpha))
    alpha = 0.5;
end


sig_links1 = output1.fdr < alpha;
sig_links2 = output2.fdr < alpha;

co_links = sig_links1 & sig_links2; 

if exist('output2d','var')
    sig_links = output2d.fdr < q;
    co_links = co_links & sig_links;
end


