function hdfig = plothist(tscore, pvalue)

hdfig = figure('Units', 'Normalized',...
                'Tag', 'ttesthistogram',...
                'Visible', 'off');
subplot(1,2,1);
bw = .5;
edge = findedge(tscore);
edges = -edge:bw:edge;
hgt1 = histc(tscore,edges);
bar(edges,hgt1,'histc');
h = findobj(gca,'Type','patch');
set(h,'FaceColor',[1.0 0.3 0.3], 'EdgeColor', 'w')
xlim([min(tscore)-0.5 max(tscore)+0.5]);
title('t-scores')
xlabel('t-score');
ylabel('Frequency');

subplot(1,2,2)
hist(pvalue, 0.025:0.05:.975);
h = findobj(gca,'Type','patch');
set(h,'FaceColor',[0.5 0.5 0.8], 'EdgeColor', 'w')
title('p-values')
xlabel('p-value');
ylabel('Frequency')

suptitle('Histograms of t-test Results')
set(hdfig, 'visible', 'on')
end




function n = getUpperGeneNumber(n)
% Return the rounded upper gene number
% for example, 3893 genes, return 4000

fn = floor(log10(n));
cn = ceil(log10(n));
if cn-fn == 0
    return;
end

m = ceil(n/(10^fn));
n = m*10^fn;
end
%---------------------------------------------------
function edge = findedge(t)
% return the rounded max |t|
maxt = getUpperGeneNumber(abs(max(t)));
mint = getUpperGeneNumber(abs(min(t)));
edge = max(maxt, mint);
end

