function output = pvalue(dat, grp, threshold, vartype)
%The program for the pvalue of the Dataset
%% Gan Xinjun, Fudan University

[d,n] = size(dat);
lg = length(grp);
if abs(n-lg) > eps
    error('The size of data and group are not consistent');
end

% type is Eq of Neq for the variance
if (~exist('vartype','var') || isempty(vartype))
    vartype = 'N';   % default as Neq
end

if (~exist('threshold','var') || isempty(threshold))
    threshold = 0.05;   % default as 1
end

[t, p, df]= hypotest(dat, grp, vartype);
plothist(t, p);
output.stat = t;
output.pvalue = p;
index = p < threshold;
vec = (1:d)';
output.th = sortrows([t(index),p(index),vec(index)],2); % sort by pvalue   

