function [difference, se] = sam_tstat(dat,grp,type)
%% Get the numerator and denominator of the t-test of SAM
% 
%% Gan Xinjun, Fundan University, CCSB
label = unique(grp);
IND1 = grp == label(1);
IND2 = ~IND1;
% Row means
x = dat(:, IND1);
y = dat(:, IND2);

% The numerator of the test
difference = nanmean(y,2) - nanmean(x,2);

%The denominator of the test
nx = size(x, 2);
ny = size(y, 2);
s2x = nanvar(x,[],2);
s2y = nanvar(y,[],2);
if strcmp(type,'N') % unequal case
    s2xbar = s2x ./ nx;
    s2ybar = s2y ./ ny;
    dfe = (s2xbar + s2ybar) .^2 ./ (s2xbar.^2 ./ (nx-1) + s2ybar.^2 ./ (ny-1));
    se = sqrt(s2xbar + s2ybar);
else     % equal case
    dfe = nx + ny - 2;
    sPooled = sqrt(((nx-1) .* s2x + (ny-1) .* s2y) ./ dfe);
    se = sPooled .* sqrt(1./nx + 1./ny);
end
