function [stat_perm, p_value, vec_false] = samperm_proc(dat,grp,nperm,stat_ob,s0,vartype,n_subset)
%% The permutation procedure of sam
% provided by Eric NIMPAYE, UAE-ENSAT-MISC, 2013.on exchange files in the
% website of mathworks. With a few modifications to fit our COMMON package
%


% if (~exist('nperm','var') || isempty(nperm))
%     nperm = 1000;   % initialize the number of permutation 
% end

if (~exist('n_subset','var') || isempty(n_subset))
    n_subset = 10;   
end


if nperm <= 0
    error('The number of permutation must be positive integer');
end

if abs(nperm - round(nperm))>eps
    warning('The number of permutation must be positive integer');
end
nperm = round(nperm); % gurrantee nperm as a positive integer

grp = grp(:);
[dim,n] = size(dat);
lg = length(grp);
if abs(n-lg) > eps
    error('The size of data and group are not consistent');
end

%perm_full = factorial(n);
grp_perm = zeros(nperm,n);
%% get the permutation of grp
for i = 1:nperm
    ind_perm = randperm(n);
    grp_perm (i, :) = grp(ind_perm)';
end


%% get d_perm and p_perm for null distribution
% This is copy from Eric NIMPAYE, UAE-ENSAT-MISC, 2013.
%

buff_seq = 1:n_subset:nperm;
buff_seq = [buff_seq, nperm+1];
seq_samp = unique (buff_seq);
n_int = length (seq_samp) - 1;

stat_mat = zeros (dim, n_int);
mat_neg = zeros (dim, n_int);
mat_pos = zeros (dim, n_int);

minus_abs_d = - abs (stat_ob);
[~, buff_ranks] = sort (minus_abs_d);
[~, stat_rank] = sort (buff_ranks);

seq_on_rows = 1:dim;
stat_flat = stat_ob(:)';% d_flat = reshape (stat_ob, 1, length(stat_ob));
hw = waitbar(0,'Please wait, Permuting...');
for j = 1:n_int
    % waitbar
    buff_grp = grp_perm (seq_samp (j):(seq_samp (j+1) - 1), :);
   
    % dperm_out = build_dperm (dat, buff_grp, type_mt, seq_samp);
    statperm_out = zeros (dim, size(buff_grp,1));
    for i = 1:size(buff_grp,1)
        [difference, se] = sam_tstat(dat,buff_grp(i,:),vartype);
        statperm_out(:,i) = sort (difference ./ (se + s0));
    end
%     if sum (sum (isnan (dperm_out))) ~= 0
%         dperm_out = purge_nan (dperm_out);
%     end
    
       
%     if sum (sum (isnan (dperm_out))) ~= 0
%         dperm_out = purge_nan (dperm_out);
%     end
    
    stat_mat (:, j) = mean (statperm_out, 2) * size (buff_grp, 1);
    
    %positive matrix
    xp = sum (sum (statperm_out >= 0)) + seq_on_rows;
    
    buff_abs = abs (stat_flat);
    
    buff_pos = statperm_out (statperm_out >= 0);
    
    statperm_flat_pos = reshape (buff_pos, 1,...
        size (buff_pos, 1) * size (buff_pos, 2));
    
    yp = - [statperm_flat_pos, buff_abs];
    
    [~, buff_ranky] = sort (yp);
    [~, buff_ranks] = sort (buff_ranky);

    %buff_ranks = ranking (a_y);
    
    dump_ord = buff_ranks (xp);
    
    mat_pos (:, j) = dump_ord' - stat_rank;
    
    %negative matrix
    xn = sum (sum (statperm_out < 0)) + seq_on_rows;
    
    buff_abs = -abs (stat_flat);
    
    buff_neg = statperm_out (statperm_out < 0);
    
    statperm_flat_neg = reshape (buff_neg, 1,...
        size (buff_neg, 1) * size (buff_neg, 2));
    
    yn = - [statperm_flat_neg, buff_abs];
    
    [~, buff_ranky] = sort (yn);
    [~, buff_ranks] = sort (buff_ranky);

    dump_ord = buff_ranks (xn);
    
    mat_neg (:, j) = dump_ord' - stat_rank;
    
    waitbar(j/n_int,hw)
end
delete(hw);
stat_perm = sum (stat_mat, 2) / nperm;

p_value = (sum (mat_pos, 2) + sum (mat_neg, 2)) / (dim * nperm);
vec_false = zeros (dim, 1);
vec_false (stat_ob >= 0) = sum (mat_pos (stat_ob >= 0, :), 2) / nperm;

